ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.9 by root, Tue Dec 7 20:03:15 2010 UTC vs.
Revision 1.14 by root, Fri Dec 10 20:29:17 2010 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11 10
12# perl build variables 11# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
15PERL_CONFIGURE="" # additional Configure arguments 13PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 14PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 15PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 16
52postconfigure() { : ; } 50postconfigure() { : ; }
53postbuild() { : ; } 51postbuild() { : ; }
54postinstall() { : ; } 52postinstall() { : ; }
55 53
56# now source user config, if any 54# now source user config, if any
55if [ "$STATICPERLRC" ]; then
56 . "$STATICPERLRC"
57else
57[ -r /etc/staticperlrc ] && . /etc/staticperlrc 58 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
58[ -r ~/.staticperlrc ] && . ~/.staticperlrc 59 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
59[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 60 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
61fi
60 62
61############################################################################# 63#############################################################################
62# support 64# support
65
66MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
67PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
68
69unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
70export LC_ALL=C # just to be on the safe side
63 71
64# set version in a way that Makefile.PL can extract 72# set version in a way that Makefile.PL can extract
65VERSION=VERSION; eval \ 73VERSION=VERSION; eval \
66$VERSION=0.1 74$VERSION=0.9
67 75
68BZ2=bz2 76BZ2=bz2
69BZIP2=bzip2 77BZIP2=bzip2
70 78
71fatal() { 79fatal() {
104############################################################################# 112#############################################################################
105# clean 113# clean
106 114
107distclean() { 115distclean() {
108 verblock <<EOF 116 verblock <<EOF
109deleting everything installed by this script 117 deleting everything installed by this script (rm -rf $STATICPERL)
110EOF 118EOF
111 119
112 rm -rf "$STATICPERL" 120 rm -rf "$STATICPERL"
113} 121}
114 122
147 verblock <<EOF 155 verblock <<EOF
148unpacking perl 156unpacking perl
149EOF 157EOF
150 158
151 mkdir -p unpack 159 mkdir -p unpack
152 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xC unpack \ 160 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
153 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 161 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
154 chmod -R u+w unpack/perl-$PERL_VERSION 162 chmod -R u+w unpack/perl-$PERL_VERSION
155 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 163 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
156 rmdir -p unpack 164 rmdir -p unpack
157 fi 165 fi
254 verblock <<EOF 262 verblock <<EOF
255installing $STATICPERL/src/perl-$PERL_VERSION 263installing $STATICPERL/src/perl-$PERL_VERSION
256to $PERL_PREFIX 264to $PERL_PREFIX
257EOF 265EOF
258 266
259 rm -rf "$PERL_PREFIX" 267 ln -sf "perl/bin/" "$STATICPERL/bin"
260 268 ln -sf "perl/lib/" "$STATICPERL/lib"
269
270 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
271 rm -rf "$PERL_PREFIX" # by this rm -rf
272
261 make install || fatal "make install: error while installing" 273 make install || fatal "make install: error while installing"
262 274
263 rcd "$PERL_PREFIX" 275 rcd "$PERL_PREFIX"
264 276
265 # create a "make install" replacement for CPAN 277 # create a "make install" replacement for CPAN
266 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 278 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
267make install UNINST=1 279make || exit
280
268if find blib/arch/auto -type f | grep -q -v .exists; then 281if find blib/arch/auto -type f | grep -q -v .exists; then
269 echo Probably an XS module, rebuilding perl 282 echo Probably an XS module, rebuilding perl
270 make perl 283 if make perl; then
271 rm -f "$PERL_PREFIX"/bin/perl 284 mv perl "$PERL_PREFIX"/bin/perl
272 make -f Makefile.aperl inst_perl
273 make -f Makefile.aperl map_clean 285 make -f Makefile.aperl map_clean
286 else
287 make -f Makefile.aperl map_clean
288 exit 1
289 fi
274fi 290fi
291
292make install UNINST=1
275EOF 293EOF
276 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 294 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
277 295
278 # trick CPAN into avoiding ~/.cpan completely 296 # trick CPAN into avoiding ~/.cpan completely
279 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 297 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
294 ' || fatal "error while initialising CPAN" 312 ' || fatal "error while initialising CPAN"
295 313
296 touch "$PERL_PREFIX/staticstamp.install" 314 touch "$PERL_PREFIX/staticstamp.install"
297 fi 315 fi
298 316
299 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall"; then 317 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
300 NOCHECK_INSTALL=+ 318 NOCHECK_INSTALL=+
301 instcpan $STATICPERL_MODULES 319 instcpan $STATICPERL_MODULES
302 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 320 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
303 321
304 postinstall || fatal "postinstall hook failed" 322 postinstall || fatal "postinstall hook failed"
385} 403}
386 404
387bundle() { 405bundle() {
388 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 406 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
389 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 407 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
408 CACHE="$STATICPERL/cache"
409 mkdir -p "$CACHE"
390 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 410 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
391} 411}
392 412
393if [ $# -gt 0 ]; then 413if [ $# -gt 0 ]; then
394 while [ $# -gt 0 ]; do 414 while [ $# -gt 0 ]; do
395 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 415 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
396 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 416 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
397 417
398 command="${1#--}"; shift 418 command="${1#--}"; shift
399 case "$command" in 419 case "$command" in
420 version )
421 echo "staticperl version $VERSION"
422 ;;
400 fetch | configure | build | install | clean | distclean) 423 fetch | configure | build | install | clean | distclean)
401 verblock <<EOF
402$command
403EOF
404 ( "$command" ) 424 ( "$command" )
405 ;; 425 ;;
406 instsrc ) 426 instsrc )
407 ( instsrc "$@" ) 427 ( instsrc "$@" )
408 exit 428 exit
422 exit 442 exit
423 ;; 443 ;;
424 mkperl ) 444 mkperl )
425 ( install ) 445 ( install )
426 bundle --perl "$@" 446 bundle --perl "$@"
447 exit
448 ;;
449 mkapp )
450 ( install )
451 bundle --app "$@"
427 exit 452 exit
428 ;; 453 ;;
429 help ) 454 help )
430 podusage 2 455 podusage 2
431 ;; 456 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines